#!/bin/bash

#	Polycute - The reference Polycute implementation
#	Copyright (C) 2012-2013  Nicholas Tomlinson
#	
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#	
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#	
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.

VERSION=`date "+%Y%m%d%H%M%S"`

echo "[*] Cleaning source directory"
scons --clean
rm -f .sconsign.dblite polycute*.tar.gz
test/tools/clean.sh

echo "[*] Copying files: $VERSION"
mkdir polycute-$VERSION
cp -r SConstruct package.sh src test polycute-$VERSION
cp /usr/share/licenses/common/GPL3/license.txt polycute-$VERSION/COPYING
cp LICENSE polycute-$VERSION/

echo "[*] Removing extra files"
rm -rf polycute-$VERSION/test/rbm/dataset polycute-$VERSION/test/rbm2/dataset

echo "[*] Taring files"
tar cf polycute-$VERSION.tar polycute-$VERSION

echo "[*] Compressing tar file"
gzip -9 polycute-$VERSION.tar

echo "[*] Cleaning package directory"
rm -r polycute-$VERSION

echo "[*] Extracting tar file"
tar xf polycute-$VERSION.tar.gz

echo "[*] Building test build"
cd polycute-$VERSION
scons -j `nproc` --debug-build

echo "[*] Running tests"
test/tools/test.sh

echo "[*] Cleaning up"
cd ../
rm -r polycute-$VERSION

echo "[*] Done"
