/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_LLVM_CODEGEN_HPP
#define CODEGEN_LLVM_CODEGEN_HPP

#include "../codegen.hpp"

class CodeGeneratorLlvm : public CodeGenerator
{
	public:
		CodeGeneratorLlvm(AstNode *node);
		
	protected:
		std::string GetDebug(CompileContext &context, unsigned int d);
};


/*
 * This is the LLVM instance of the CodeGeneratorRoot
 */
class CodeGeneratorRootLlvm : public CodeGeneratorLlvm
{
	public:
		AstType(AstNodeRoot);
		
		CodeGeneratorRootLlvm(AstNodeRoot *node);
		virtual CodeGeneratorRootLlvm *Copy();
		virtual std::string Generate(std::string directory, CompileContext &context); //this method returns the LLVM code for its node and its node's children
};

#include "type.hpp"
#include "expression.hpp"
#include "statement.hpp"
#include "function.hpp"
#include "dynvect.hpp"
#include "reference.hpp"

#endif

