/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_LLVM_CTRLFLOW_HPP
#define CODEGEN_LLVM_CTRLFLOW_HPP

class CodeGeneratorStatementForLlvm : public CodeGeneratorStatementLlvm
{
	public:
		CodeGeneratorStatementForLlvm(AstNodeStatementFor *node);
		virtual CodeGeneratorStatementForLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnBegin(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnEnd(CompileContext &context, unsigned int d);
		virtual std::string GenerateTopLevel(CompileContext &context, unsigned int d);
		
		AstType(AstNodeStatementFor);
	private:
		unsigned int m_id;
};

class CodeGeneratorStatementWhileLlvm : public CodeGeneratorStatementLlvm
{
	public:
		CodeGeneratorStatementWhileLlvm(AstNodeStatementWhile *node);
		virtual CodeGeneratorStatementWhileLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnBegin(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnEnd(CompileContext &context, unsigned int d);
		virtual std::string GenerateTopLevel(CompileContext &context, unsigned int d);
		
		AstType(AstNodeStatementWhile);
};

class CodeGeneratorStatementIfLlvm : public CodeGeneratorStatementLlvm
{
	public:
		CodeGeneratorStatementIfLlvm(AstNodeStatementIf *node);
		virtual CodeGeneratorStatementIfLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnBegin(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnEnd(CompileContext &context, unsigned int d);
		virtual std::string GenerateTopLevel(CompileContext &context, unsigned int d);
		
		AstType(AstNodeStatementIf);
};

#include "parallel.hpp"

#endif
