/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_LLVM_STRUCT_HPP
#define CODEGEN_LLVM_STRUCT_HPP

#include "type.hpp"
#include "expression.hpp"

class CodeGeneratorStructDeclarationLlvm : public CodeGeneratorLlvm
{
	public:
		CodeGeneratorStructDeclarationLlvm(AstNodeStructDeclaration *node);
		virtual CodeGeneratorStructDeclarationLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d);
		
		AstType(AstNodeStructDeclaration);
};

class CodeGeneratorTypeStructLlvm : public CodeGeneratorTypeLlvm
{
	public:
		CodeGeneratorTypeStructLlvm(AstNodeTypeStruct *node);
		virtual CodeGeneratorTypeStructLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d);
		virtual unsigned int GetSize(CompileContext &context);
		virtual std::string GenerateDebug(CompileContext &context, unsigned int d);
		virtual std::string GenerateTopLevel(CompileContext &context, unsigned int d);
		
		virtual std::string GenerateCreate(CompileContext &context, unsigned int d, unsigned int value);
		virtual std::string GenerateDestroy(CompileContext &context, unsigned int d, unsigned int value);
		virtual std::string GenerateCopy(CompileContext &context, unsigned int d, unsigned int src, unsigned int dst);
		
		AstType(AstNodeTypeStruct);
};

class CodeGeneratorExpressionLValueStructElementLlvm : public CodeGeneratorExpressionLValueLlvm
{
	public:
		CodeGeneratorExpressionLValueStructElementLlvm(AstNodeExpressionLValueStructElement *node);
		virtual CodeGeneratorExpressionLValueStructElementLlvm *Copy();
		virtual std::string Generate(CompileContext &context, unsigned int d, unsigned int n);
		virtual std::string GenerateStore(CompileContext &context, unsigned int d, unsigned int n);
		virtual std::string GenerateFnBegin(CompileContext &context, unsigned int d);
		virtual std::string GenerateFnEnd(CompileContext &context, unsigned int d);
		virtual std::string GenerateReference(CompileContext &context, unsigned int d, unsigned int n);
		
		AstType(AstNodeExpressionLValueStructElement);
};

#endif
