/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_OPENCL_CODEGEN_HPP
#define CODEGEN_OPENCL_CODEGEN_HPP

#include "../codegen.hpp"

class CodeGeneratorOpencl : public CodeGenerator
{
	public:
		CodeGeneratorOpencl(AstNode *node);
};

class CodeGeneratorRootOpencl : public CodeGeneratorOpencl
{
	public:
		AstType(AstNodeRoot);
		
		CodeGeneratorRootOpencl(AstNodeRoot *node);
		virtual CodeGeneratorRootOpencl *Copy();
		virtual std::string Generate(CompileContext &context);
		std::vector<uint8_t> GenerateBinary(CompileContext &context);
};

#include "type.hpp"
#include "expression.hpp"
#include "statement.hpp"
#include "function.hpp"

#endif

