/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_OPENCL_STRUCT_HPP
#define CODEGEN_OPENCL_STRUCT_HPP

#include "type.hpp"
#include "expression.hpp"

class CodeGeneratorStructDeclarationOpencl : public CodeGeneratorOpencl
{
	public:
		CodeGeneratorStructDeclarationOpencl(AstNodeStructDeclaration *node);
		virtual CodeGeneratorStructDeclarationOpencl *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeStructDeclaration);
};

class CodeGeneratorTypeStructOpencl : public CodeGeneratorTypeOpencl
{
	public:
		CodeGeneratorTypeStructOpencl(AstNodeTypeStruct *node);
		virtual CodeGeneratorTypeStructOpencl *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeTypeStruct);
};

class CodeGeneratorExpressionLValueStructElementOpencl : public CodeGeneratorExpressionLValueOpencl
{
	public:
		CodeGeneratorExpressionLValueStructElementOpencl(AstNodeExpressionLValueStructElement *node);
		virtual CodeGeneratorExpressionLValueStructElementOpencl *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeExpressionLValueStructElement);
};

#endif
 
