/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_PSEUDOPC_CTRLFLOW_HPP
#define CODEGEN_PSEUDOPC_CTRLFLOW_HPP

class CodeGeneratorStatementForPseudopc : public CodeGeneratorStatementPseudopc
{
	public:
		CodeGeneratorStatementForPseudopc(AstNodeStatementFor *node);
		virtual CodeGeneratorStatementForPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeStatementFor);
};

class CodeGeneratorStatementWhilePseudopc : public CodeGeneratorStatementPseudopc
{
	public:
		CodeGeneratorStatementWhilePseudopc(AstNodeStatementWhile *node);
		virtual CodeGeneratorStatementWhilePseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeStatementWhile);
};

class CodeGeneratorStatementIfPseudopc : public CodeGeneratorStatementPseudopc
{
	public:
		CodeGeneratorStatementIfPseudopc(AstNodeStatementIf *node);
		virtual CodeGeneratorStatementIfPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeStatementIf);
};

#include "parallel.hpp"

#endif
