/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_PSEUDOPC_FUNCTION_HPP
#define CODEGEN_PSEUDOPC_FUNCTION_HPP

class CodeGeneratorFunctionDeclarationPseudopc : public CodeGeneratorPseudopc
{
	public:
		CodeGeneratorFunctionDeclarationPseudopc(AstNodeFunctionDeclaration *node);
		virtual CodeGeneratorFunctionDeclarationPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeFunctionDeclaration);
};

class CodeGeneratorExpressionFunctionCallPseudopc : public CodeGeneratorExpressionPseudopc
{
	public:
		CodeGeneratorExpressionFunctionCallPseudopc(AstNodeFunctionCall *node);
		virtual CodeGeneratorExpressionFunctionCallPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeFunctionCall);
};

#endif
