/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "../../ast/astnode.hpp"
#include "codegen.hpp"



CodeGeneratorExpressionBinaryPseudopc::CodeGeneratorExpressionBinaryPseudopc(AstNodeExpressionBinary *node, std::string op) :
	CodeGeneratorExpressionPseudopc(node), m_op(op)
{
}

CodeGeneratorExpressionBinaryPseudopc *CodeGeneratorExpressionBinaryPseudopc::Copy()
{
	return new CodeGeneratorExpressionBinaryPseudopc(GetNode(), m_op);
}

std::string CodeGeneratorExpressionBinaryPseudopc::Generate(CompileContext &context)
{
	return PrintString("(%s) %s (%s)",
		GetNode()->GetA()->GetCodeGenerator<CodeGeneratorExpressionPseudopc>()->Generate(context).c_str(),
		m_op.c_str(),
		GetNode()->GetB()->GetCodeGenerator<CodeGeneratorExpressionPseudopc>()->Generate(context).c_str()
	);
}



CodeGeneratorExpressionCastPseudopc::CodeGeneratorExpressionCastPseudopc(AstNodeExpressionCast *node) :
	CodeGeneratorExpressionPseudopc(node)
{
}

CodeGeneratorExpressionCastPseudopc *CodeGeneratorExpressionCastPseudopc::Copy()
{
	return new CodeGeneratorExpressionCastPseudopc(GetNode());
}

std::string CodeGeneratorExpressionCastPseudopc::Generate(CompileContext &context)
{
	return PrintString("%s (%s)",
		GetNode()->GetType()->GetCodeGenerator<CodeGeneratorTypePseudopc>()->Generate(context).c_str(),
		GetNode()->GetExpression()->GetCodeGenerator<CodeGeneratorExpressionPseudopc>()->Generate(context).c_str()
  	);
}


