/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CODEGEN_PSEUDOPC_STRUCT_HPP
#define CODEGEN_PSEUDOPC_STRUCT_HPP

#include "type.hpp"
#include "expression.hpp"

class CodeGeneratorStructDeclarationPseudopc : public CodeGeneratorPseudopc
{
	public:
		CodeGeneratorStructDeclarationPseudopc(AstNodeStructDeclaration *node);
		virtual CodeGeneratorStructDeclarationPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeStructDeclaration);
};

class CodeGeneratorTypeStructPseudopc : public CodeGeneratorTypePseudopc
{
	public:
		CodeGeneratorTypeStructPseudopc(AstNodeTypeStruct *node);
		virtual CodeGeneratorTypeStructPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeTypeStruct);
};

class CodeGeneratorExpressionLValueStructElementPseudopc : public CodeGeneratorExpressionLValuePseudopc
{
	public:
		CodeGeneratorExpressionLValueStructElementPseudopc(AstNodeExpressionLValueStructElement *node);
		virtual CodeGeneratorExpressionLValueStructElementPseudopc *Copy();
		virtual std::string Generate(CompileContext &context);
		
		AstType(AstNodeExpressionLValueStructElement);
};

#endif
