/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COMPILE_HPP
#define COMPILE_HPP

bool Compile(
	/* Inputs and stuff */
	std::string input_filename,
	
	/* Program outputs */
	std::string llvm_filename,
	std::string pseudopc_filename,
	std::string computespec_output_filename,
	
	/* Options */
	std::string polycute_library_directory,
	
	/* Optimisation stuff */
	std::list<std::string> optimisers,
	std::string optimisation_report_filename,
	std::string astdot_filename,
	std::string asttext_filename,
	
	/* Debug stuff */
	bool debug,
	bool llvm_header,
	bool llvm_lines
);

#endif

