/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "compilecontext.hpp"

CompileContext::CompileContext(bool debug, bool debug_llvm_header, bool debug_llvm_lines) :
	m_debug(debug), m_debug_llvm_header(debug_llvm_header), m_debug_llvm_lines(debug_llvm_lines)
{
}

ComputeSpec &CompileContext::GetComputeSpec()
{
	return m_compute_spec;
}

bool CompileContext::GetDebug()
{
	return m_debug;
}

bool CompileContext::GetDebugLlvmHeader()
{
	return m_debug_llvm_header;
}

bool CompileContext::GetDebugLlvmLines()
{
	return m_debug_llvm_lines;
}
