/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <cinttypes>
#include <unistd.h>
#include <cstring>
#include <map>
#include <set>

#include "computespec.hpp"
#include "../util.hpp"



ComputeSpec::ComputeSpec()
{
}

ComputeSpecMachineCpu ComputeSpec::GetCpu()
{
	return m_cpu;
}

void ComputeSpec::Autodetect()
{
	m_cpu.Autodetect();
	
	#ifdef OPENCL
		m_gpu.Autodetect();
	#endif
}

std::string ComputeSpec::GetSpecSource()
{
	std::string result;
	result += m_cpu.GetSpecSource();
	
	#ifdef OPENCL
		result += m_gpu.GetSpecSource();
	#endif
	
	return result;
}

