/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

%{
	#include "computespec.hpp"
	#include "computespec.yy.hpp"
	#include "computespec.ll.hpp"
	#include "../error.hpp"
	
	#define DoParserError ((ComputeSpecParserData *)parserdata)->error = true;
	#define PrintCompilerError(...) PrintCompilerErrorYyl(((ComputeSpecParserData *)parserdata)->filename, yylloc, __VA_ARGS__) DoParserError
	
	void yyerror(const char *);
	
	#define YYPARSE_PARAM parserdata
	#define YYLEX_PARAM  ((yyscan_t *)(((ComputeSpecParserData *)parserdata)->scanner))[0]
	
	void yyerror (YYLTYPE *locp, void *parserdata, char const *msg)
	{
		YYLTYPE yylloc = *locp;
		PrintCompilerError("%s", msg);
	}
	
	#define computespec (((ComputeSpecParserData *)parserdata)->spec)
%}

/* Setup stuff */
%define api.prefix computespec_
%pure_parser
%lex-param {YYLEX_PARAM}
%locations
%error-verbose
%token_table
%parse-param {void *parserdata}

%start start

/* Tokens */
%token MACHINE "machine"

%token TRUE "true"
%token FALSE "false"

%token IDENTIFIER "identifier"
%token INTEGER "integer constant"
%token DECIMAL "floating point constant"

%token END 0 "end of file"


/* Presedence */


/* Types */

%union {
	const char *text;
	bool boolean;
	unsigned int integer;
	double floating_point;
	char identifier[1024];
};

/* %type <boolean> boolean
%type <integer> integer
%type <floating_point> float

%type <integer> INTEGER
%type <floating_point> DECIMAL */

%%

/* Top Level */
start: root_list;
root_list:
	root_item root_list |
	;
	
root_item:
	machine;

machine:
	MACHINE; //{computespec.test();};

/* boolean:
	TRUE {$$ = true;} |
	FALSE {$$ = false;};
integer:
	INTEGER {$$ = $1;};
float:
	DECIMAL {$$ = $1;}; */

