/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COMPUTESPEC_GPU_HPP
#define COMPUTESPEC_GPU_HPP

#include "../cl/cl.hpp"

class ComputeSpecMachineGpu : public ComputeSpecMachine
{
	public:
		ComputeSpecMachineGpu();
		
		virtual void Autodetect();
		virtual std::string GetSpecSource();
		
		unsigned int GetSizeT();
		unsigned int GetCoreCount();
		unsigned int GetSimdWidth();
		uint64_t GetMemorySize();
		
		static std::string GetOpenCLInfo();
		
	private:
		unsigned int m_size_t;
		unsigned int m_core_count;
		unsigned int m_simd_width;
		uint64_t m_memory_size;
};

#endif

 
