/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PARSER_PARSER_HPP
#define PARSER_PARSER_HPP

#define YYSTYPE POLYCUTE_PARSER_STYPE
#define YYLTYPE POLYCUTE_PARSER_LTYPE

#include "../ast/astnode.hpp"

typedef struct ParserData
{
	void *scanner;
	const char *filename;
	AstNodeRoot *top;
	bool error;
} ParserData;


/* Structs used during parsing */
struct FunctionAttributes
{
	bool ccall;
	bool exported;
	bool imported;
	bool lock;
};

#endif
