/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef UTIL_HPP
#define UTIL_HPP

#include <cinttypes>
#include <string>


#ifdef __GNUC__
	std::string PrintString(const char *format, ...)  __attribute__((format(printf, 1, 2)));
#else
	std::string PrintString(const char *format, ...);
#endif

unsigned int GetUniqueId();
std::string Indent(std::string s, unsigned int n);
int64_t GetMilliTime();
void WriteToFile(std::string text, std::string filename);

//Bit oh a hack putting this here
#define LlvmDebugVersion 0xC0000

#endif
