/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2012-2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>

uint32_t fn(float a, float b);
uint32_t fact(uint32_t n);
uint32_t factr(uint32_t n);
uint32_t add4(uint32_t a, uint32_t b, uint32_t c, uint32_t d);
int segtest(uint32_t *p);
void addn(uint32_t *a, uint32_t *b, uint32_t *c, uint32_t n);
uint32_t add2 (uint32_t a, uint32_t b);
uint32_t GetMeaningOfLife();

int main(int argc, char **argv)
{
	uint32_t v = 1;
	printf("Segtest: %u, %u\n", segtest(&v), (unsigned int)v);
	printf("fn(5.5, 2.2): %u\n", (unsigned int)fn(5.5, 2.2));
	printf("fact(10): %u\n", (unsigned int)fact(10));
	printf("factr(10): %u\n", (unsigned int)factr(10));
	printf("add4(1, 2, 3, 4): %u\n", (unsigned int)add4(1, 2, 3, 4));
	printf("add2(2, 3): %u\n", (unsigned int)add2(2, 3));
	printf("GetMeaningOfLife(): %u\n", (unsigned int)GetMeaningOfLife());
	
	uint32_t a[64];
	uint32_t b[64];
	uint32_t c[64];
	
	for (unsigned int i = 0; i < 64; i++){
		a[i] = i;
		b[i] = i + 1;
	}
	
	addn(a, b, c, 64);
	
	printf("addn():\n\t");
	for (unsigned int i = 0; i < 64; i++){
		printf("%03u ", (unsigned int)a[i]);
	} printf("\n\t");
	for (unsigned int i = 0; i < 64; i++){
		printf("%03u ", (unsigned int)b[i]);
	} printf("\n\t");
	for (unsigned int i = 0; i < 64; i++){
		printf("%03u ", (unsigned int)c[i]);
	} printf("\n");
	
	return 0;
}
