/*
	Polycute - The reference Polycute implementation
	Copyright (C) 2013  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#define __STDC_FORMAT_MACROS
#include <inttypes.h>

static void BubbleSort(uint64_t n, uint32_t *array)
{
	int sorted = 0;
	while (!sorted){
		sorted = 1;
		for (uint64_t i = 0; i < n-1; i++){
			if (array[i] > array[i + 1]){
				sorted = 0;
				uint32_t tmp = array[i];
				array[i] = array[i + 1];
				array[i + 1] = tmp;
			}
		}
	}
}

void Sort(uint64_t n, uint32_t *a1, uint32_t *a2)
{
	if (n < 8){
		BubbleSort(n, a1);
	}
	else {
		uint64_t partition = n/(uint64_t)2;
		uint64_t minspawn = 100000000;
		
		if (n > minspawn){
			#pragma omp parallel
			Sort(partition, a1, a2);
			#pragma omp parallel
			Sort(n - partition, a1 + partition, a2 + partition);
		}
		else {
			Sort(partition, a1, a2);
			Sort(n - partition, a1 + partition, a2 + partition);
		}
		
		uint64_t a = 0;
		uint64_t b = partition;
		uint64_t i = 0;
		
		while ((a < partition) && (b < n)){
			if (a1[a] < a1[b]){
				a2[i] = a1[a];
				a++;
				i++;
			}
			else {
				a2[i] = a1[b];
				b++;
				i++;
			}
		}
		
		while (a < partition){
			a2[i] = a1[a];
			a++;
			i++;
		}
		
		while (b < n){
			a2[i] = a1[b];
			b++;
			i++;
		}
		
		for (uint64_t j = 0; j < n; j++){
			a1[j] = a2[j];
		}
	}
}
