#include <cstdio>
#include <cinttypes>
#include <random>


extern "C" uint64_t Sum(uint64_t n);

static void Do(uint64_t n)
{
	fprintf(stderr, "[-] Summing %" PRIu64 " items\n", n);
	printf("[*] Sum is: %" PRIu64 "\n", Sum(n));
	fprintf(stderr, "[-] Finished summing\n");
}

extern "C" uint32_t Generate()
{
	static std::uniform_int_distribution<uint32_t> distribution(0, 0xFFFFFFFF);
	static std::mt19937 engine; // Mersenne twister MT19937
	
	return distribution(engine);
}

extern "C" void PrintMessage(uint64_t n)
{
	switch (n)
	{
		case 0: fprintf(stderr, "[+] Beginning summation\n"); break;
		case 1: fprintf(stderr, "[+] Ending summation\n"); break;
		case 2: fprintf(stderr, "[-] Allocating memory\n"); break;
		case 3: fprintf(stderr, "[-] Generating integers\n"); break;
		case 4: fprintf(stderr, "[-] Deallocating memory\n"); break;
		default: fprintf(stderr, "[-] Unknown message\n");
	}
}

int main(int argc, char **argv)
{
	Do(10);
	Do(1000);
	Do(100000);
	Do(10000000);
	//Do(1000000000);
	return 0;
}
